moSetGetAnimals = {};

function moSetGetAnimals:setAnimalsUpdate(self)	
	moAnimals = {};	
	moDefault.warningAnimalsProductivity = 100;	
	moDefault.animalsObjects = 0;
	local animals = g_currentMission.husbandries;				
	function setLsAnimals(name, tableAnimals, ls)
		moDefault.animalsObjects = moDefault.animalsObjects+1;
		local id = moDefault.animalsObjects;			
		moAnimals[id] = {};
		moAnimals[id].lsTyp = ls;
		moAnimals[id].animalName = name;
		if not string.find(moDefault.foundAnimals, name.. " ") then moDefault.foundAnimals = moDefault.foundAnimals.. name.. " ";end;		
		local fruitName, bestPrice = getNameAndPrice(self, name);
		moAnimals[id].bestPrice = string.format("%.1f", Utils.getNoNil(bestPrice, 0));
		moAnimals[id].typeName = g_i18n:getText("statisticView_".. name);
		moAnimals[id].num = string.format("%1.0f", Utils.getNoNil(tableAnimals.totalNumAnimals, 0));			
		moAnimals[id].productivity = string.format("%1.0f", Utils.getNoNil(tableAnimals.productivity*100, 0)); --string.format("%0.0f", Utils.getNoNil(0, 0));
		moAnimals[id].productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['green'];
		setAnimalsProductivityColor(self, id);
		if tostring(name) == "chicken" then setLsAnimalChicken(name, tableAnimals, id);end;
		if tostring(name) == "sheep" then setLsAnimalSheep(name, tableAnimals, id);end;
		if tostring(name) == "cow" then setLsAnimalCow(name, tableAnimals, id);end;
	end;
	function setLsAnimalChicken(name, tableAnimals, id)
		moAnimals[id].amount = string.format("%1.0f", Utils.getNoNil(g_currentMission:getSiloAmount(Fillable.FILLTYPE_EGG), 0));			
		moAnimals[id].pickupEgg = string.format("%1.0f", Utils.getNoNil(tableAnimals.numActivePickupObjects, 0));	
		moAnimals[id].pickupEggColor = moGuiMiniPDAsetGet.warningColor0;			
		local egg = tonumber(moAnimals[id].pickupEgg);
		if egg >= 54 then moAnimals[id].pickupEggColor = moGuiMiniPDAsetGet.warningColor3;end;
		if egg < 54 and egg >= 40 then moAnimals[id].pickupEggColor = moGuiMiniPDAsetGet.warningColor2;end;
		if egg < 40 and egg >= 20 then moAnimals[id].pickupEggColor = moGuiMiniPDAsetGet.warningColor1;end;			
		moAnimals[id].wheatFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals:getFillLevel(Fillable.FILLTYPE_WHEAT), 0));			
		moAnimals[id].waterFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals:getFillLevel(Fillable.FILLTYPE_WATER), 0));			
	end;
	function setLsAnimalSheep(name, tableAnimals, id)
		moAnimals[id].amountWool = 0;
		moAnimals[id].amountWoolColor = moGuiMiniPDAsetGet.siloColor
		moAnimals[id].palCapacity = 0;
		moAnimals[id].forageFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals:getFillLevel(Fillable.FILLTYPE_FORAGE), 0));
		moAnimals[id].woolProzent = 0;
		if animals.sheep.currentPallet ~= nil then 
			moAnimals[id].amountWool = string.format("%1.0f", Utils.getNoNil(tableAnimals.currentPallet.fillLevel, 0));
			moAnimals[id].palCapacity = string.format("%1.0f", Utils.getNoNil(tableAnimals.currentPallet.capacity, 0));			
			local checkCapacity = tonumber(moAnimals[id].amountWool)/tonumber(moAnimals[id].palCapacity)*100;
			moAnimals[id].woolProzent = checkCapacity;
			if checkCapacity >= 85 then moAnimals[id].amountWoolColor = moGuiMiniPDAsetGet.warningColor3;end;
			if checkCapacity <= 85 and checkCapacity >= 50 then moAnimals[id].amountWoolColor = moGuiMiniPDAsetGet.warningColor2;end;
			if checkCapacity <= 50 and checkCapacity >= 25 then moAnimals[id].amountWoolColor = moGuiMiniPDAsetGet.warningColor0;end;
		end;
		moAnimals[id].palWoolColor = moGuiMiniPDAsetGet.warningColor0;
		if moMapObjects ~= nil and moMapObjects["woolsheepPalCollector"] ~= nil and moMapObjects["woolsheepPalCollector"].objCreate ~= nil then			
			moAnimals[id].fremdObj = false;
			local objCreate = moMapObjects["woolsheepPalCollector"].objCreate;
			moAnimals[id].fillPal = 0;
			local fremdObj = objCreate.fremdObject;
			if fremdObj ~= nil and fremdObj > 0 then moAnimals[id].fremdObj = true;end;
			moAnimals[id].maxPal = table.getn(objCreate.Points);
			local noticePal = 0;
			if moAnimals[id].maxPal ~= nil and moAnimals[id].maxPal > 1 then
				for i = 1, moAnimals[id].maxPal do
					if objCreate.Points[i].Pallet ~= nil then
						noticePal = noticePal+1;					
					end;
				end;
			end;
			moAnimals[id].fillPal = moAnimals[id].fillPal+noticePal;			
			if moAnimals[id].fillPal >= moAnimals[id].maxPal then moAnimals[id].palWoolColor = moGuiMiniPDAsetGet.warningColor4;end;
			if moAnimals[id].fillPal >= moAnimals[id].maxPal/2 and moAnimals[id].fillPal < moAnimals[id].maxPal then moAnimals[id].palWoolColor = moGuiMiniPDAsetGet.warningColor2;end;			
		end;
		moAnimals[id].waterFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals:getFillLevel(Fillable.FILLTYPE_WATER), 0));					
	end;
	function setLsAnimalCow(name, tableAnimals, id)
		moAnimals[id].amountMilk = string.format("%1.0f", Utils.getNoNil(tableAnimals.fillLevelMilk, 0));		
		moAnimals[id].autoSellMilk = "Off";
		moAnimals[id].autoSellMilkColor = moGuiMiniPDAsetGet.warningColor3;		
		moAnimals[id].forageFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals:getFillLevel(Fillable.FILLTYPE_FORAGE), 0));			
		moAnimals[id].silageFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals:getFillLevel(Fillable.FILLTYPE_SILAGE), 0));
		moAnimals[id].grassFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals:getFillLevel(Fillable.FILLTYPE_GRASS_WINDROW), 0));
		moAnimals[id].strawFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals:getFillLevel(Fillable.FILLTYPE_WHEAT_WINDROW), 0));
		moAnimals[id].amountManure = string.format("%1.0f", Utils.getNoNil(tableAnimals.manureHeap.fillLevel, 0));
		moAnimals[id].amountLiquidManure = string.format("%1.0f", Utils.getNoNil(tableAnimals.liquidManureTrigger.fillLevel, 0));			
		moAnimals[id].waterFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals:getFillLevel(Fillable.FILLTYPE_WATER), 0));			
	end;		
	function setModAnimals(name, tableAnimals, ls)
		moDefault.animalsObjects = moDefault.animalsObjects+1;
		local id = moDefault.animalsObjects;
		moAnimals[id] = {};
		moAnimals[id].lsTyp = ls;
		moAnimals[id].animalName = tableAnimals.animal;
		if not string.find(moDefault.foundAnimals, tableAnimals.animal.. " ") then moDefault.foundAnimals = moDefault.foundAnimals.. tableAnimals.animal.. " ";end;
		--moDefault.foundAnimals = moDefault.foundAnimals.. tableAnimals.animal.. " ";
		local fruitName, bestPrice = getNameAndPrice(self, tableAnimals.animal);
		moAnimals[id].bestPrice = string.format("%.1f", Utils.getNoNil(bestPrice, 0));
		moAnimals[id].typeName = fruitName;
		moAnimals[id].animalType = unpack(moLanguage.extern["breeding".. moDefault.language]);
		moAnimals[id].typeAnimal = "breeding";
		if tableAnimals.fattening ~= nil and tableAnimals.fattening then moAnimals[id].animalType = unpack(moLanguage.extern["mast".. moDefault.language]);moAnimals[id].typeAnimal = "mast";end;
		moAnimals[id].num = string.format("%1.0f", Utils.getNoNil(tableAnimals.numPig, 0)); --Utils.getNoNil(tableAnimals.numPig, 0);			
		moAnimals[id].numBuy = string.format("%1.0f", Utils.getNoNil(tableAnimals.numSchweine, 0)); --Utils.getNoNil(tableAnimals.numSchweine, 0);						
		moAnimals[id].numBuyColor = moGuiMiniPDAsetGet.siloColor;
		if tonumber(moAnimals[id].numBuy) > 0 then moAnimals[id].numBuyColor = moGuiMiniPDAsetGet.warningColor0;end;			
		moAnimals[id].productivity = string.format("%1.0f", Utils.getNoNil(tableAnimals.Produktivi*100, 0));
		moAnimals[id].productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['green']; 
		setAnimalsProductivityColor(self, id);
		moAnimals[id].forageFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals.FutterTypLvl[4], 0)); --mischration
		moAnimals[id].grainFruitFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals.FutterTypLvl[1], 0)); --grainFruit
		moAnimals[id].earthFruitFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals.FutterTypLvl[2], 0)); --earthFruit			
		moAnimals[id].silageFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals.FutterTypLvl[3], 0)); --silofutter											
		moAnimals[id].waterFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals.FutterTypLvl[5], 0));
		moAnimals[id].strawFillLevel = string.format("%1.0f", Utils.getNoNil(tableAnimals.FutterTypLvl[6], 0));
		moAnimals[id].amountManure = string.format("%1.0f", Utils.getNoNil(tableAnimals.manureHeap.FillLvl, 0));
		moAnimals[id].amountLiquidManure = string.format("%1.0f", Utils.getNoNil(tableAnimals.liquidManureSiloTrigger.fillLevel, 0));				
	end;		
	if animals ~= nil then		
		moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "animals ", "");
		for k, v in pairs(animals) do
			if tostring(k) == "sheep" or tostring(k) == "cow" then
				if v.totalNumAnimals >= 1 then setLsAnimals(k, v, true);end;			
			end;
			if tostring(k) == "chicken" then
				if v.totalNumAnimals >= 2 then setLsAnimals(k, v, true);end;			
			end;
		end;
	end;
	if moAnimalMapObjects ~= nil then
		moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "animals ", "");
		for k, v in pairs(moAnimalMapObjects) do
			if k ~= nil and moAnimalMapObjects[k] ~= nil then				
				local objTable = moAnimalMapObjects[k].objCreate
				if objTable.numPig >= 1 or objTable.numSchweine >= 1 then setModAnimals(k, objTable, false);end;
			end;
		end;
	end;
	if animals == nil and moAnimalMapObjects == nil then
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "animals ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."animals ";end;
	else
		moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "animals ", "");
	end;
end;

function setAnimalsProductivityColor(self, id)
	local ratio = moAnimals[id].productivity;
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		moAnimals[id].productivityColor = moGuiMiniPDAsetGet.warningColor1; --moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		moAnimals[id].productivityColor = moGuiMiniPDAsetGet.warningColor2; --moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		moAnimals[id].productivityColor = moGuiMiniPDAsetGet.warningColor3; --moGuiExtras.colors['red'];
	elseif tonumber(ratio) < 25 then
		moAnimals[id].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
	if tonumber(moDefault.warningAnimalsProductivity) >= tonumber(ratio) then 
		moDefault.warningAnimalsProductivity = tonumber(ratio);	
	end;
end;

function getNameAndPrice(self, name)
	local bestPrice = 0;
	local fruitName = "unknow"	
	local desc = Fillable.fillTypeNameToDesc[name];
	if desc ~= nil and moFillTypes[desc.index] ~= nil then 
		fruitName = moFillTypes[desc.index].fruitName;
		bestPrice = moFillTypes[desc.index].pricePerLiter/1000*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
	end;
	return fruitName, bestPrice;
end;